#include <Wire.h>
#include <MPU6050_light.h>
#include <Mouse.h>
#include <Keyboard.h>
#include "RotaryEncoder.h"
#include "OneButton.h"     

MPU6050 mpu(Wire);
unsigned long timer = 0;
int Xang, Yang, Zang;
int buttonState = 0;
int button = 7;
int led = 11; 

bool invertZoom = true;

OneButton button1(0, true);

RotaryEncoder encoder(8, 9);

static int pos = 0;
int newPos;
int scrollPos = 0;
 
void setup() {
  Serial.begin(9600);
  //pinMode(button, INPUT);
  pinMode(led, OUTPUT);
  Wire.begin();
  mpu.begin();
  delay(1000);
  mpu.calcOffsets(); 
  Mouse.begin();      
  Keyboard.begin(); 
  digitalWrite(led, HIGH);


  // link the button 1 functions.
  button1.attachClick(singleClick_1);
  button1.attachDoubleClick(doubleClick_1);
  button1.attachLongPressStop(longPressStop_1);
  button1.attachDuringLongPress(longPress_1);
}


void loop() {
  mpu.update();
  button1.tick();
  encoder.tick();
  newPos = encoder.getPosition();
        
  if ((millis() - timer) > 50) { 

    //Reading the MPU data
    Xang=mpu.getAngleX();
    Yang=mpu.getAngleY();
    Zang=mpu.getAngleZ();

    //Logic for the Mouse and Keyboard movements
  if (buttonState == 0)  {
      if  (Yang > 6) {  
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(map(Yang, 6, 10, 1, 10), 0 , 0);
      }

      else if (Yang < -6) {
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(map(Yang, -10, -6, -10, -1), 0 , 0); 
      }
      
    
      else if  (Xang > 6) {  
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(0, map(Xang, 6, 10, 1, 10) , 0, 0); 
      }

      else if (Xang < -6) {
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(0, map(Xang, -10, -6, -10, -1) , 0, 0); 
      }

      else if ( newPos > pos) {
        pos = newPos;
        if (invertZoom == false){
          scrollPos = -2;
          Mouse.move(0, 0, scrollPos);
        }

        else if (invertZoom == true){
          scrollPos = 2;
          Mouse.move(0, 0, scrollPos);
        }
      }

      else if ( pos > newPos){ 
        pos = newPos; 
        if (invertZoom == false){
          scrollPos = 2;
          Mouse.move(0, 0, scrollPos);
        }
        else if (invertZoom == true){
          scrollPos = -2;
          Mouse.move(0, 0, scrollPos);
        }        
      }

      else  {   
          Mouse.release(MOUSE_MIDDLE);

      }

  }

  else if (buttonState == 1)   {
      if  (Yang > 6) {
        Keyboard.press(KEY_RIGHT_SHIFT);  
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(map(Yang, 6, 10, 1, 10), 0 , 0); 
      }

      else if (Yang < -6) {
        Keyboard.press(KEY_RIGHT_SHIFT);
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(map(Yang, -10, -6, -10, -1), 0 , 0); 
      }
      
    
      else if  (Xang > 6) {  
        Keyboard.press(KEY_RIGHT_SHIFT);
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(0, map(Xang, 6, 10, 1, 10) , 0, 0); 
      }

      else if (Xang < -6) {
        Keyboard.press(KEY_RIGHT_SHIFT);
        Mouse.press(MOUSE_MIDDLE);
        Mouse.move(0, map(Xang, -10, -6, -10, -1) , 0, 0); 
      }


      else  {   
          Mouse.release(MOUSE_MIDDLE);
          Keyboard.release(KEY_RIGHT_SHIFT);
      }
  }
    
    timer = millis();
  }
            
} // Closing void (loop)

// ############ FUNCTIONS ###############

void pressed () {
    buttonState = !buttonState;
    }

// ----- button 1 callback functions

// This function will be called when the button1 was pressed 1 time (and no 2. button press followed).
void singleClick_1() {
  Serial.println("Button 1 click.");
} // End of singleClick_1

// This function will be called when the button1 was pressed 2 times in a short timeframe.
void doubleClick_1() {
  Serial.println("Button 1 doubleclick.");
} // End of doubleClick_1

// This function will be called often, while the button1 is pressed for a long time.
void longPress_1() {
  Serial.println("Button 1 longPress...");
} // End of longPress_1

// This function will be called once, when the button1 is released after beeing pressed for a long time.
void longPressStop_1() {
  Serial.println("Button 1 longPress stop");
}

 // ############ END OF FUNCTIONS ###############